( function( $ ) {
    "use strict";
    var Product_Category_Template_PostType= function(){
        var self = this;
        self.elmPublish = '#mstcprcfvc-publish-template';
        self.elmUpdate = '#mstcprcfvc-update-template';

        self.btnSavechange = '.mstcprcfvc-savechange-editting';
        // INIT
        self.init = function() {   
            self.generateHTML();
            // PUBLISH
            $(document).on( 'click', self.elmPublish, function(event) {
                event.preventDefault();
                self.publishTemplate( $(this) );
            });
            // UPDATE
            $(document).on( 'click', self.elmUpdate, function(event) {
                event.preventDefault();
                self.updateTemplate( $(this) );
            });
            
        };

        self.generateHTML = function () {
            $(window).off('beforeunload');//Disable “Changes you made may not be saved” pop-up window.
            $('.wrap').prepend('<div id="mstcprcfvc-message" class="updated mstcprcfvc-alert-savechange"><p class="mstcprcfvc-save-change"></p></div>');
            $('#publishing-action').html('');
            var html_action = '',
                addnew      = '',
                save_text   = '';
            if(mstcprcfvc_data.is_page=='adnew'){
                html_action = '<button class="button button-primary button-large" id="mstcprcfvc-publish-template">'+mstcprcfvc_data.publish+'</button>';
                $('#vc_navbar .vc_navbar-nav').prepend('<li class="vc_pull-right"><a class="vc_btn vc_btn-sm vc_navbar-btn vc_btn-primary mstcprcfvc-savechange-editting" id="mstcprcfvc-publish-template">'+mstcprcfvc_data.publish+'</a></li>');
                $('.wp-heading-inline').text(mstcprcfvc_data.add_template);
                save_text = mstcprcfvc_data.saved;
            }else{
                html_action = '<button class="button button-primary" id="mstcprcfvc-update-template">'+mstcprcfvc_data.update+'</button>';
                $('#vc_navbar .vc_navbar-nav').prepend('<li class="vc_pull-right"><a class="vc_btn vc_btn-sm vc_navbar-btn vc_btn-primary mstcprcfvc-savechange-editting" id="mstcprcfvc-update-template">'+mstcprcfvc_data.update+'</a></li>');
                addnew = mstcprcfvc_data.edit_template+' <a href="'+mstcprcfvc_data.url_add_new+'" class="hide-if-no-js page-title-action">'+mstcprcfvc_data.add_template+'</a>';
                $(".wp-heading-inline").html(addnew);
                $('#title-prompt-text').addClass('screen-reader-text');
                $('#title').val(mstcprcfvc_data.template_name);
                save_text = mstcprcfvc_data.updated;
            }
            $('body').prepend('<div class="vc_message success mstcprcfvc-alert-message-success">'+save_text+'</div>');
            $('#publishing-action').html(html_action);
            if(mstcprcfvc_data.vc_template_custom_css){
                $('#vc_post-custom-css').val(mstcprcfvc_data.vc_template_custom_css);
                $('#vc_post-css-badge').show();
            }
        };

        self.getContentEditor = function() {
            var content= $('#wp-content-editor-container .wp-editor-area').val();
            if( content === "" && tinymce.activeEditor ) {
                content         = tinymce.activeEditor.getContent();
            }
            return content;
        }

        self.publishTemplate = function( _this ) {

            _this.addClass('updating-message');
            var btsavechange= $(self.btnSavechange);
            btsavechange.text(mstcprcfvc_data.popup_loading_text);

            $.ajax({
                url: ajaxurl,
                type: 'POST',
                data: {
                    'action'            : 'mst_product_category_publish',
                    'nonce'             : mstcprcfvc_data.nonce,
                    'post_id'           : mstcprcfvc_data.post_id,
                    'custom_css'        : $('#vc_post-custom-css').val(),
                    'template_type'     : mstcprcfvc_data.is_template,
                    'title'             : $("#title").val(),
                    'content'           : self.getContentEditor(),
                    'language'          : mstcprcfvc_data.language
                }
            })
            .done(function (res) {
                _this.removeClass('updating-message');
                btsavechange.text(mstcprcfvc_data.publish);
                if(res.success){
                    self.alertMessage(mstcprcfvc_data.saved);
                    window.location = mstcprcfvc_data.url_templates;
                } 
            })
            .fail(function (res) {
                _this.removeClass('updating-message');
                btsavechange.text(mstcprcfvc_data.publish);
                console.log(res);
            });
        };

        self.updateTemplate = function( _this ) {

            _this.addClass('updating-message');
            var btsavechange= $(self.btnSavechange);
            btsavechange.text(mstcprcfvc_data.popup_loading_text);

            $.ajax({
                url: ajaxurl,
                type: 'POST',
                data: {
                    'action'            : 'mst_product_category_update',
                    'nonce'             : mstcprcfvc_data.nonce,
                    'id'                : mstcprcfvc_data.is_page,
                    'template_type'     : mstcprcfvc_data.is_template,
                    'title'             : $("#title").val(),
                    'content'           : self.getContentEditor(),
                    'post_id'           : mstcprcfvc_data.post_id,
                    'custom_css'        : $('#vc_post-custom-css').val()
                }
            })
            .done(function (res) {
                _this.removeClass('updating-message');
                btsavechange.text(mstcprcfvc_data.update);
                if(res.success){
                    var template_text   = mstcprcfvc_data.is_template === 'loop' ? mstcprcfvc_data.loop_templates : mstcprcfvc_data.category_templates,
                        html            = '<a href="'+mstcprcfvc_data.url_templates+'">'+template_text+'</a>';
                    self.alertMessage(mstcprcfvc_data.updated+" "+html);
                } 
            })
            .fail(function (res) {
                _this.removeClass('updating-message');
                btsavechange.text(mstcprcfvc_data.update);
                console.log(res);
            });
        };

        self.alertMessage = function( alert_text ) {
            $(".mstcprcfvc-alert-savechange").show();
            $(".vc_fullscreen .vc_message.success.mstcprcfvc-alert-message-success").addClass('mstcprcfvc-updated');
            $(".mstcprcfvc-save-change").html(alert_text);
            $("html, body").animate({ scrollTop: 0 }, "200");
        }
       
    };
      
    jQuery(document).ready(function($){
        var product_category_wpb_post_type = new Product_Category_Template_PostType();
        product_category_wpb_post_type.init();
    });
    
} )( jQuery );