( function( $ ) {
    "use strict";
    var productCategoryWPB= function(){
        var self = this;
        self.classDeleteTemplate = '.product-category-wpb-delete-template';
        self.classActiveTemplate = '.product-category-wpb-active-template';
        self.classDuplicate      = '.product-category-wpb-duplicate';
        self.bntShowImportForm   = '.btn-show-form-import-product-category';
        self.classImportForm     = '.btn-import-product-category';
        self.classExportForm     = '.btn-export-product-category';
        self.importFormElement   = '#frm-import-product-category';
        // INIT
        self.init = function() {   
            $(document).on('click', self.classDeleteTemplate, function(event) {
                event.preventDefault();
                if( confirm(mstcprcfvc_data.sure_delete_this) ) {
                    var _this           = $(this),
                        _parent         = _this.closest('.woocommerce-archive-templates'),
                        _id             = _this.data('template-id'),
                        language        = _this.data('language');
                   
                    _this.addClass('updating-message');
                    self.templateAction(_parent,'delete');
                    $.ajax({
                        url  : ajaxurl,
                        type : 'POST',
                        data : {
                            'action'        : 'mst_product_category_delete',
                            'nonce'         : mstcprcfvc_data.nonce,
                            'template_type' : mstcprcfvc_data.is_template,
                            'id'            : _id,
                            'language'      : language
                        }
                    })
                    .done(function (res) {
                        _this.removeClass('updating-message');
                        if(res.success){                  
                            $('html, body').animate({ scrollTop: 0 }, '200');
                            location.reload(); // refresh page
                        } 
                    })
                    .fail(function (res) {
                        _this.removeClass('updating-message');                     
                        console.log(res);
                    });
                }
            });
            
            $(document).on('click', self.classActiveTemplate, function(event) {
                event.preventDefault();
                var _this       = $(this),
                    _parent     = _this.closest('.woocommerce-archive-templates'),
                    _id         = _this.data('template-id'),
                    language    = _this.data('language');
                _this.addClass('updating-message');
                self.templateAction(_parent,'active');
                $.ajax({
                    url: ajaxurl,
                    type: 'POST',
                    data: {
                        'action': 'mst_product_category_active',
                        'nonce' : mstcprcfvc_data.nonce,
                        'id'    : _id,
                        'language': language
                    }
                })
                .done(function (res) {
                    if(res.success)
                    {
                        _this.removeClass('updating-message');
                        $('html, body').animate({ scrollTop: 0 }, '200');
                        location.reload(); // refresh page
                    } 
                })
                .fail(function (res) {
                    _this.removeClass('updating-message');;
                    console.log(res);
                });
            });

            $(document).on('click', self.classDuplicate, function(event) {
                event.preventDefault();
                var _this       = $(this),
                    _parent     = _this.closest('.woocommerce-archive-templates'),
                    _id         = _this.data('template-id');
                _this.addClass('updating-message');
                self.templateAction( _parent, 'duplicate' );
                $.ajax({
                    url: ajaxurl,
                    type: 'POST',
                    data: {
                        'action': 'mst_product_category_duplicate',
                        'nonce' : mstcprcfvc_data.nonce,
                        'id'    : _id,
                        'type'  : mstcprcfvc_data.is_template
                    }
                })
                .done(function (res) {
                    _this.removeClass('updating-message');
                    if(res.success) {
                        $('html, body').animate({ scrollTop: 0 }, '200');
                        location.reload(); // refresh page
                    } 
                })
                .fail(function (res) {
                    _this.removeClass('updating-message');;
                    console.log(res);
                });
            });

            
            $(document).on('click', self.bntShowImportForm, function(event) {
                event.preventDefault();
                $(".form-import-product-category").toggle("slow", function() {});
            });

            $(document).on('click', self.classExportForm, function(event) {
                event.preventDefault();
                if( confirm(mstcprcfvc_data.sure) ) {
                    var _this       = $(this),
                        language    = _this.data('language');
                    _this.addClass('updating-message');
                    $.ajax({
                        url: ajaxurl,
                        type: 'POST',
                        data: {
                            'action'    : 'mst_product_category_export',
                            'nonce'     : mstcprcfvc_data.nonce,
                            'language'  : language
                        }
                    })
                    .done(function(res) {
                        _this.removeClass('updating-message');
                        if (res.success) {
                            window.document.location.href = mstcprcfvc_data.home_url + '/export-template-product-category?language=' + language;
                        }
                    })
                    .fail(function(res) {
                        _this.removeClass('updating-message');
                        console.log(res);
                    });
                }   
            });

            $(document).on('submit', self.importFormElement, function(event) {
                event.stopPropagation();
                event.preventDefault();
                var formData = new FormData();
                var importFiles = $("#file-import-product-category")[0].files;
                jQuery.each(importFiles, function(index, value) {
                  var name = "file";
                  formData.append(name, value);
                });
                var _this = $(this);
                var language = _this.find(".btn-import-product-category").data('language');
                formData.append('action', 'mst_product_category_import');
                formData.append('nonce', mstcprcfvc_data.nonce);
                formData.append('language', language);
                self.importTemplate(formData, _this);
            }); 
        };

        self.templateAction = function(_parent, action = '') {
            var action_element = _parent.find('.archive-template-action');
            action_element.show();
            switch (action) {
                case 'active':
                    action_element.html('<p>'+mstcprcfvc_data.active+'</p>');
                    break;
                case 'duplicate':
                    action_element.html('<p>'+mstcprcfvc_data.duplicate+'</p>');
                    break;
                default: // delete
                    action_element.html('<p>'+mstcprcfvc_data.delete+'</p>');
                    break;
            }
        };

        self.importTemplate = function (formData, _this) {
            _this.find(self.classImportForm).addClass("updating-message");
            $.ajax({
                url: ajaxurl,
                type: "POST",
                data: formData,
                cache: false,
                dataType: "json",
                processData: false,
                contentType: false
            })
            .done(function(res) {
                _this.find(self.classImportForm).removeClass("updating-message");
                if (res.success) {
                    location.reload();
                } else {
                    console.log(res.data.mess);
                }
            })
            .fail(function(res) {
                 console.log(res);
            });

        }
    };
      
    jQuery(document).ready(function($){
        var product_category_wpb = new productCategoryWPB();
        product_category_wpb.init();
    });
} )( jQuery );