<?php
/*
* Plugin Name: Customize Product Category for WPBakery Page Builder
* Plugin URI: https://www.persianscript.ir
* Description: with plugin this, You can customize your product category page to your style by simply dragging and dropping the interface without code, with require must have WPBakery Page Builder.
* Version: 5.0.0
* Author: پرشین اسکریپت
* Author URI: https://www.persianscript.ir
* Text Domain: customize-product-category-for-wpbakery-page-builder
*/

namespace PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER;

defined( 'ABSPATH' ) || exit;

if ( function_exists( 'PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\\plugin_init' ) ) {
	require_once plugin_dir_path( __FILE__ ) . 'includes/Fallback.php';
	add_action(
		'admin_init',
		function() {
			deactivate_plugins( plugin_basename( __FILE__ ) );
		}
	);
}

if ( ! defined( 'PRODUCT_CATEGORY_WPB_FILE' ) ) {
	define( 'PRODUCT_CATEGORY_WPB_FILE', __FILE__ );
}

if ( ! defined( 'PRODUCT_CATEGORY_WPB_VERSION' ) ) {
	define( 'PRODUCT_CATEGORY_WPB_VERSION', '5.0.0' );
}

if ( ! defined( 'PRODUCT_CATEGORY_WPB_DIR' ) ) {
	define( 'PRODUCT_CATEGORY_WPB_DIR', realpath( plugin_dir_path( __FILE__ ) ) );
}

if ( ! defined( 'PRODUCT_CATEGORY_WPB_INC' ) ) {
	define( 'PRODUCT_CATEGORY_WPB_INC', PRODUCT_CATEGORY_WPB_DIR . '/includes' );
}

if ( ! defined( 'PRODUCT_CATEGORY_WPB_URL' ) ) {
	define( 'PRODUCT_CATEGORY_WPB_URL', plugin_dir_url( __FILE__ ) );
}

spl_autoload_register(
	function ( $class ) {
		$prefix   = __NAMESPACE__;
		$base_dir = __DIR__ . '/includes';

		$len = strlen( $prefix );
		if ( strncmp( $prefix, $class, $len ) !== 0 ) {
			return;
		}

		$relative_class_name = substr( $class, $len );

		$file = $base_dir . str_replace( '\\', '/', $relative_class_name ) . '.php';

		if ( file_exists( $file ) ) {
			require $file;
		}
	}
);

if ( ! function_exists( 'PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\\plugin_init' ) ) {
	function plugin_init() {

		if ( ! defined( 'WPB_VC_VERSION' ) ) {
			add_action( 'admin_notices', array( \PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Engine\ActDeact::class, 'wpbakery_page_builder_require' ) );
			return;
		}

		if ( ! defined( 'WOOCOMMERCE_VERSION' ) ) {
			add_action( 'admin_notices', array( \PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Engine\ActDeact::class, 'woocommerce_require' ) );
			return;
		}

		Initialize::get_instance();
		load_plugin_textdomain( 'customize-product-category-for-wpbakery-page-builder', false, basename( __DIR__ ) . '/languages/' );

	}
}

if ( ! wp_installing() ) {
	add_action( 'plugins_loaded', 'PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\\plugin_init' );
}

// Active plugin
register_activation_hook( __FILE__, array( \PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Engine\ActDeact::class, 'activate' ) );
