<?php
namespace PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Engine;

use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Utils\SingletonTrait;


/**
 * Activate and deactive method of the plugin and relates.
 */
class ActDeact {

	use SingletonTrait;

	protected function __construct() {}

	public static function wpbakery_page_builder_require() {
		$plugin = get_plugin_data( PRODUCT_CATEGORY_WPB_FILE );
		echo sprintf(
			'<div class="notice error is-dismissible"><p><strong>%1$s</strong> requires <strong><a href="%2$s" target="_blank">WPbakery page builder</a></strong> plugin to be installed and activated on your site.</p></div>',
			esc_html( $plugin['Name'] ),
			esc_url( '//1.envato.market/4ePBWZ' )
		);
		return false;
	}

	public static function woocommerce_require() {
		$plugin = get_plugin_data( PRODUCT_CATEGORY_WPB_FILE );
		echo sprintf(
			'<div class="notice error is-dismissible"><p><strong>%1$s</strong> requires <strong><a href="%2$s" target="_blank">WooCommerce</a></strong> plugin to be installed and activated on your site.</p></div>',
			esc_html( $plugin['Name'] ),
			esc_url( 'https://wordpress.org/plugins/woocommerce/' )
		);
		return false;
	}

	public static function create_table( $table, $charset_collate ) {

		$sql = 'CREATE TABLE ' . $table . ' (
                      `id` int(11) NOT NULL AUTO_INCREMENT,
                      `title` varchar(255) NOT NULL,
                      `images` TEXT NULL,
                      `content` TEXT NULL,
                      `language` varchar(255) NOT NULL default "",
                      `active` int(11) NOT NULL default 0,
                      UNIQUE KEY id (id)
                      ) ' . $charset_collate . ';';
		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		dbDelta( $sql );

	}

	public static function addTableTemplates( $table ) {
		global $wpdb;
		$charset_collate = $wpdb->get_charset_collate();
		if ( $wpdb->get_var( "show tables like '$table'" ) != $table ) {
			self::create_table( $table, $charset_collate );
		}
	}

	public static function activate() {
		global $wpdb;
		$array_tables = array(
			'product_category' => 'wcpcfvc_product_category',
			'loop'             => 'wcpcfvc_loop',
		);
		foreach ( $array_tables as $key => $name ) {
			$table = $wpdb->prefix . $name;
			self::addTableTemplates( $table );
		}
	}

	public static function deactivate() {

	}

}
