<?php
namespace PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Engine\Frontend;

use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers\Helper;
use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers\SupportHelper;
use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Utils\SingletonTrait;

defined( 'ABSPATH' ) || exit;

class Frontend {
	use SingletonTrait;

	public function __construct() {

		add_action( 'wp_enqueue_scripts', array( $this, 'wp_enqueue_scripts' ) );
		add_action( 'template_redirect', array( $this, 'callback_redirect_template' ), 9999 );

	}

	public function wp_enqueue_scripts() {
		if ( Helper::is_product_category() ) {
			do_action( 'product_category_wpb_wp_enqueue_scripts' );
			wp_enqueue_style( 'woocommerce-category-wpb-frontend', PRODUCT_CATEGORY_WPB_URL . 'assets/css/frontend.css', array(), PRODUCT_CATEGORY_WPB_VERSION );
			wp_enqueue_script( 'woocommerce-category-wpb-frontend', PRODUCT_CATEGORY_WPB_URL . 'assets/js/frontend.js', array( 'jquery' ), PRODUCT_CATEGORY_WPB_VERSION, true );
			$data = array();
			wp_localize_script(
				'woocommerce-category-wpb-frontend',
				'mstcprcfvc_data',
				$data
			);
		}
	}

	public function callback_redirect_template() {

		if ( Helper::is_product_category() ) {
			$term_id      = Helper::get_term_id();
			$has_template = Helper::get_template_active_by_language( $term_id );
			if ( $has_template && $has_template['active'] ) {
				add_filter( 'template_include', array( $this, 'callback_apply_template_redirect' ), 9999 );
			}
		}

	}

	public function callback_apply_template_redirect( $template ) {
		$template_redirect = PRODUCT_CATEGORY_WPB_INC . '/views/archive-product.php';
		if ( file_exists( $template_redirect ) ) {
			return $template_redirect;
		}
		return $template;
	}

}
