<?php

namespace PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers;

use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Utils\SingletonTrait;

class FontHelper {

	use SingletonTrait;
	protected function __construct() {}

	public static function getFontsData( $fontsString ) {
		$googleFontsParam = new \Vc_Google_Fonts();
		$fieldSettings    = array();
		$fontsData        = strlen( $fontsString ) > 0 ? $googleFontsParam->_vc_google_fonts_parse_attributes( $fieldSettings, $fontsString ) : '';
		return $fontsData;
	}

	public static function googleFontsStyles( $fontsData ) {
		$fontFamily   = explode( ':', $fontsData['values']['font_family'] );
		$styles[]     = 'font-family:' . $fontFamily[0];
		$fontStyles   = explode( ':', $fontsData['values']['font_style'] );
		$styles[]     = 'font-weight:' . $fontStyles[1];
		$styles[]     = 'font-style:' . $fontStyles[2];
		$inline_style = '';
		foreach ( $styles as $attribute ) {
			$inline_style .= $attribute . '; ';
		}
		return $inline_style;
	}

	public static function enqueueGoogleFonts( $fontsData ) {
		$settings = get_option( 'wpb_js_google_fonts_subsets' );
		if ( is_array( $settings ) && ! empty( $settings ) ) {
			$subsets = '&subset=' . implode( ',', $settings );
		} else {
			$subsets = '';
		}
		if ( isset( $fontsData['values']['font_family'] ) ) {
			wp_enqueue_style(
				'vc_google_fonts_' . vc_build_safe_css_class( $fontsData['values']['font_family'] ),
				'//fonts.googleapis.com/css?family=' . $fontsData['values']['font_family'] . $subsets,
				array(),
				PRODUCT_CATEGORY_WPB_VERSION
			);
		}
	}

	public static function getCSSAnimation( $css_animation ) {
		$output = '';
		if ( '' !== $css_animation && 'none' !== $css_animation ) {
			wp_enqueue_script( 'waypoints' );
			wp_enqueue_style( 'animate-css' );
			$output = ' wpb_animate_when_almost_visible wpb_' . $css_animation . ' ' . $css_animation;
		}

		return $output;
	}

}
