<?php
namespace PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers;

use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers\Helper;
use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Utils\SingletonTrait;

class SupportHelper {

	use SingletonTrait;

	protected function __construct() {}

	public static function layout_with_salient_theme( $type = 'before_main_content' ) {
		global $main_shop_layout;
		switch ( $type ) {
			case 'before_main_content':
				echo '<div class="container-wrap" data-midnight="dark">';
				if ( 'right-sidebar' != $main_shop_layout && 'left-sidebar' != $main_shop_layout ) {
					echo '<div class="container main-content">';
					if ( 'fullwidth' === $main_shop_layout ) {
						echo '<div style="padding: 0 15px;" class="full-width-content nectar-shop-outer">';
					}
					echo '<div class="nectar-shop-header">';
					remove_action( 'nectar_shop_header_markup', 'nectar_shop_header_bottom_markup_output', 10 );
					do_action( 'nectar_shop_header_markup' );
				} else {
					remove_action( 'nectar_shop_header_bottom_secondary_markup', 'woocommerce_result_count', 10 );
					remove_action( 'nectar_shop_header_bottom_secondary_markup', 'woocommerce_catalog_ordering', 10 );
					do_action( 'woocommerce_before_main_content' );
				}
				break;
			case 'after_main_content':
				if ( 'right-sidebar' != $main_shop_layout && 'left-sidebar' != $main_shop_layout ) {
					echo '</div>';
					if ( 'fullwidth' === $main_shop_layout ) {
						echo '</div>';
					}
					echo '</div>';
				} else {
					do_action( 'woocommerce_after_main_content' );
				}
				echo '</div>';
				break;
			case 'woocommerce_product_sorting':
				if ( 'right-sidebar' != $main_shop_layout && 'left-sidebar' != $main_shop_layout ) {
					echo '<div class="nectar-shop-header">';
					remove_action( 'nectar_shop_header_markup', 'woocommerce_breadcrumb', 10 );
					remove_action( 'nectar_shop_header_markup', 'salient_woo_shop_title', 10 );
					add_action( 'nectar_shop_header_markup', 'nectar_shop_header_bottom_markup_output', 10 );
					do_action( 'nectar_shop_header_markup' );
					echo '</div>';
				} else {
					echo '<div class="nectar-shop-header">';
					add_action( 'nectar_shop_header_bottom_secondary_markup', 'woocommerce_result_count', 10 );
					add_action( 'nectar_shop_header_bottom_secondary_markup', 'woocommerce_catalog_ordering', 10 );
					echo '<div class="nectar-shop-header-bottom"><div class="left-side"></div><div class="right-side">';
					do_action( 'nectar_shop_header_bottom_secondary_markup' );
					echo '</div></div></div>';
				}
				break;
			case 'start_sidebar':
				if ( is_active_sidebar( 'woocommerce-sidebar' ) ) {
					remove_action( 'nectar_shop_above_loop', 'nectar_shop_header_output', 10 );
					switch ( $main_shop_layout ) {
						case 'right-sidebar':
							nectar_shop_wrapper_start_sidebar_right();
							break;
						case 'left-sidebar':
							nectar_shop_wrapper_start_sidebar_left();
							break;
						default:
							break;
					}
				}
				break;
			case 'end_sidebar':
				if ( is_active_sidebar( 'woocommerce-sidebar' ) ) {
					switch ( $main_shop_layout ) {
						case 'right-sidebar':
							nectar_shop_wrapper_end_sidebar_right();
							break;
						case 'left-sidebar':
							nectar_shop_wrapper_end_sidebar_left();
							break;
						default:
							break;
					}
				}
				break;
			default:
				break;
		}
	}

	// EXCUTE COMPATIBLE BASEL THEME (GET ALL PRODUCT BU COLUMN AND AJAX LOAD MORE,...)
	public static function get_basel_list_products( $products_columns ) {
		global $product;
		$is_slider       = basel_loop_prop( 'is_slider' );
		$is_shortcode    = basel_loop_prop( 'is_shortcode' );
		$different_sizes = basel_loop_prop( 'products_different_sizes' );
		$hover           = basel_loop_prop( 'product_hover' );
		$current_view    = basel_loop_prop( 'products_view' );
		$shop_view       = basel_get_opt( 'shop_view' );
		update_option( 'mst_basel_custom_columns', $products_columns );
		// Ensure visibility
		if ( ! $product || ( ! $is_slider && ! $product->is_visible() ) ) {
			return;
		}
		// Increase loop count
		basel_set_loop_prop( 'woocommerce_loop', (int) basel_loop_prop( 'woocommerce_loop' ) + 1 );
		$woocommerce_loop = basel_loop_prop( 'woocommerce_loop' );
		// Extra post classes
		$classes = array( 'product-grid-item' );
		//Grid or list style
		if ( 'grid' === $shop_view || 'list' === $shop_view ) {
			$current_view = $shop_view;
		}
		if ( $is_slider ) {
			$current_view = 'grid';
		}
		if ( $is_shortcode ) {
			$current_view = basel_loop_prop( 'products_view' );
		}
		if ( 'list' === $current_view ) {
			$hover = 'list';
			basel_set_loop_prop( 'products_columns', 1 );
			$classes[] = 'product-list-item';
		} else {
			$classes[] = 'basel-hover-' . $hover;
		}
		$classes[] = 'product';

		if ( $different_sizes && in_array( $woocommerce_loop, basel_get_wide_items_array( $different_sizes ) ) ) {
			basel_set_loop_prop( 'double_size', true );
		}
		$xs_columns = (int) basel_get_opt( 'products_columns_mobile' ) ? (int) basel_get_opt( 'products_columns_mobile' ) : 2;
		$xs_size    = 12 / $xs_columns;
		if ( 1 == $products_columns ) {
			$xs_size = 12;
		}
		if ( ! $is_slider ) {
			$classes[] = basel_get_grid_el_class( $woocommerce_loop, $products_columns, $different_sizes, $xs_size );
		} else {
			$classes[] = 'product-in-carousel';
		}
		//WC 3.4
		$post_class = 'post_class';
		if ( function_exists( 'WC' ) && WC()->version >= '3.4' ) {
			$post_class = 'wc_product_class';
		}
		?>
		<div <?php $post_class( $classes, $product ); ?> data-loop="<?php echo esc_attr( $woocommerce_loop ); ?>" data-id="<?php echo esc_attr( $product->get_id() ); ?>">
			<?php wc_get_template_part( 'content', 'product-' . $hover ); ?>
		</div>
		<?php

		if ( ! $is_slider && ! basel_loop_prop( 'products_masonry' ) && 'list' != $current_view ) {
			echo basel_get_grid_clear( $woocommerce_loop, $products_columns ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
		}
	}

	public static function basel_excute_pagination( $fragments = false ) {
		global $paged, $wp_query;
		$max_page = $wp_query->max_num_pages;
		$columns  = intval( get_option( 'mst_basel_custom_columns' ) );
		if ( $fragments ) {
			ob_start();
		}
		if ( $fragments && isset( $_GET['loop'] ) ) {
			basel_set_loop_prop( 'woocommerce_loop', sanitize_text_field( (int) $_GET['loop'] ) );
		}
		if ( have_posts() ) {
			if ( ! $fragments ) {
				woocommerce_product_loop_start();
			}
			if ( wc_get_loop_prop( 'total' ) || $fragments ) :
				while ( have_posts() ) :
					the_post();
					self::get_basel_list_products( $columns );
				endwhile; // end of the loop.
			endif;

			if ( ! $fragments ) {
				woocommerce_product_loop_end();
			}

			if ( ! $fragments ) {
				do_action( 'woocommerce_after_shop_loop' );
			}
		} else {
			do_action( 'woocommerce_no_products_found' );
		}

		if ( $fragments ) {
			$output = ob_get_clean();
		}

		if ( $fragments ) {
			$output = array(
				'items'    => $output,
				'status'   => ( $max_page > $paged ) ? 'have-posts' : 'no-more-posts',
				'nextPage' => str_replace( '&#038;', '&', next_posts( $max_page, false ) ),
			);
			echo json_encode( $output );
		}
	}

	// GOYA THEME
	public static function get_goya_list_products( $hide_sorting = '', $hide_paginate = '' ) {
		if ( woocommerce_product_loop() ) {
			if ( empty( $hide_sorting ) ) {
				do_action( 'goya_shop_toolbar' );
				Helper::woocommerce_product_sorting( Helper::current_theme() );
			}

			global $woocommerce_loop;
			// Set column sizes (large column is set via theme setting)
			$woocommerce_loop['columns_small']  = '2';
			$woocommerce_loop['columns_medium'] = '3';
			$woocommerce_loop['shop_archive']   = true;
			woocommerce_product_loop_start();
			if ( wc_get_loop_prop( 'total' ) ) {
				while ( have_posts() ) {
					the_post();
					do_action( 'woocommerce_shop_loop' );
					wc_get_template_part( 'content', 'product' );
				}
			}
			woocommerce_product_loop_end();
			if ( empty( $hide_paginate ) ) {
				do_action( 'woocommerce_after_shop_loop' );
			}
		} else {
			do_action( 'woocommerce_no_products_found' );
		}
	}

	public static function get_product_category_default_params_by_themes() {
		$theme   = Helper::current_theme();
		$default = array(
			'type'        => 'textfield',
			'admin_label' => true,
			'heading'     => __( 'Extra class name', 'js_composer' ),
			'param_name'  => 'el_class',
			'save_always' => true,
			'value'       => '',
			'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' ),
		);
		switch ( $theme ) {
			case 'electro':
				$params = array(
					array(
						'type'        => 'dropdown',
						'admin_label' => true,
						'heading'     => __( 'Sidebar position', 'customize-product-category-for-wpbakery-page-builder' ),
						'param_name'  => 'sidebar_postition',
						'save_always' => true,
						'description' => __( 'Sidebar position that you want appear', 'customize-product-category-for-wpbakery-page-builder' ),
						'value'       => array(
							'Left'  => 'left',
							'Right' => 'right',
						),
						'std'         => 'left',
					),
					$default,
				);

				break;

			default:
				$params = array( $default );
				break;
		}

		return $params;

	}
}
