<?php
use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers\Helper;
defined( 'ABSPATH' ) || exit;

global $woocommerce_loop, $wp_query;

$is_sale_page   = $wp_query->is_sale_page;
$is_latest_page = $wp_query->is_latest_page;
$is_main_shop   = is_shop();

// OnSale page plugin
if ( $is_sale_page || $is_latest_page ) {
	$is_main_shop = false;
}

$show_filters_sidebar = false;
$show_filters_popup   = false;
$show_filters_header  = false;
$shop_class[]         = 'shop-container';

// Full Width Catalog
$shop_full_width = goya_meta_config( '', 'shop_full_width', false );
$shop_class[]    = ( $shop_full_width ) ? 'shop-full-width' : '';

$filter_scroll = ( get_theme_mod( 'shop_filters_scrollbar', true ) == true ) ? 'shop-widget-scroll' : '';

// Sidebar/Filters
$filters         = get_theme_mod( 'shop_filters', true );
$filter_position = goya_meta_config( 'shop', 'filter_position', 'header' );

if ( $filters ) {
	if ( 'sidebar' === $filter_position ) {
		$show_filters_sidebar = true;
		$shop_class[]         = 'shop-sidebar-' . $filter_position . ' shop-sidebar-position-' . get_theme_mod( 'shop_filters_sidebar_position', 'left' );
	} else {
		$shop_class[] = 'shop-sidebar-' . $filter_position;

		if ( 'popup' === $filter_position ) {
			$show_filters_popup = true;
		}
		if ( 'header' === $filter_position ) {
			$show_filters_header = true;
		}
	}
}

// Get category ID
$cate   = get_queried_object();
$cateID = ( ! is_shop() ) ? $cate->term_id : false;

// Shop Header Style
$shop_hero_title = goya_meta_config( 'shop', 'hero_title', 'none' );
$shop_header_bg  = get_theme_mod( 'shop_header_bg', array() );

$header_class[]  = 'hero-header';
$header_bg_class = array();

if ( 'none' != $shop_hero_title ) {

	if ( $is_main_shop && ! is_search() ) {
		if ( ! empty( get_theme_mod( 'shop_header_bg_image', '' ) ) ) {
			$header_bg_class[] = 'parallax_image';
			$header_bg_class[] = 'vh-height';
		}
		$header_bg_class[] = 'hero-title';
	} elseif ( is_tax() ) {
		$term_id   = get_queried_object()->term_id;
		$header_id = get_term_meta( $term_id, 'header_id', true );
		$image     = wp_get_attachment_url( $header_id, 'full' );

		if ( ! empty( $image ) ) {
			$header_bg_class[] = 'parallax_image';
			$header_bg_class[] = 'vh-height';
		}

		if ( 'main-hero' != $shop_hero_title ) {
			$header_bg_class[] = 'hero-title';
		} else {
			$header_class[]    = 'page-padding';
			$header_bg_class[] = 'regular-title';
		}
	} elseif ( $is_sale_page || $is_latest_page ) {
		$image_url = get_the_post_thumbnail_url( get_queried_object_id(), 'full' );
		if ( $image_url ) {
			$header_bg_class[] = 'parallax_image';
			$header_bg_class[] = 'vh-height';
		}
		if ( 'main-hero' != $shop_hero_title ) {
			$header_bg_class[] = 'hero-title';
		} else {
			$header_class[]    = 'page-padding';
			$header_bg_class[] = 'regular-title';
		}
	} elseif ( 'main-hero' != $shop_hero_title ) {
		$header_bg_class[] = 'hero-title';
	} else {
		$header_class[]    = 'page-padding';
		$header_bg_class[] = 'regular-title';
	}
} else {
	$header_class[]    = 'page-padding';
	$header_bg_class[] = 'regular-title';
}

?>
<div class="<?php echo esc_attr( implode( ' ', $header_class ) ); ?>">
		<div class="<?php echo esc_attr( implode( ' ', $header_bg_class ) ); ?>">
			<div class="container hero-header-container">
				<header class="row woocommerce-products-header">
					<div class="col-lg-8">

						<?php if ( apply_filters( 'woocommerce_show_page_title', true ) ) : ?>
							<h1 class="et-shop-title woocommerce-products-header__title page-title"><?php woocommerce_page_title(); ?></h1>
						<?php endif; ?>
						
						<?php
						if ( ( $is_main_shop || is_product_category() ) && ! is_search() && get_theme_mod( 'shop_categories_list', true ) == true ) {
							goya_subcategories_by_id( apply_filters( 'goya_shop_header_subcategories', $cateID ) );
						}
						?>
					</div>
				</header>
			</div>
		</div>
</div>
<?php do_action( 'woocommerce_before_main_content' ); ?>
<div class="<?php echo esc_attr( implode( ' ', $shop_class ) ); ?>">
	<div id="shop-products"  class="shop-products product-category-wpb-goya-wrapper">
		<div class="row">
			<div class="shop-products-col col">
				<?php Helper::show_template_content( $template_id, $content ); ?>
			</div>
		</div>
		<?php do_action( 'woocommerce_after_main_content' ); ?>
	</div>
		
</div>

