<?php
use PRODUCT_CATEGORY_WPBAKERY_PAGE_BUILDER\Helpers\Helper;

$sidebar          = get_theme_mod( 'c_shop_sidebar', 'full' );
$wide             = get_theme_mod( 'c_shop_full', false );
$container        = 'container';
$sidebar_position = '';
$col_class        = 'col-md-9 col-lg-9';

if ( true == $wide ) {
	$container = 'shop-container-fluid';
}

if ( is_active_sidebar( 'shop-widget' ) ) {
	if ( 'right' == $sidebar ) {
		$sidebar_position = 'shop-right-sidebar';
	} elseif ( 'left' == $sidebar ) {
		$sidebar_position = 'shop-left-sidebar';
	} else {
		$sidebar_position = 'shop-not-sidebar';
		$col_class        = 'col-md-12 col-lg-12';
	}
} else {
	$sidebar          = 'full';
	$sidebar_position = 'shop-not-sidebar';
	$col_class        = 'col-md-12 col-lg-12';
}

$view_style = get_theme_mod( 'c_shop_view_style', 'grid' );

?>

<main id="main" class="flw">
	<div class="<?php echo esc_attr( $container ); ?>">
		<div class="row woo-archive <?php echo esc_attr( $sidebar_position ); ?>">
			<div class="shop-archive-content theme-product-block shop-view-<?php echo esc_attr( $view_style ); ?> <?php echo esc_attr( $col_class ); ?>">
				<?php Helper::show_template_content( $template_id, $content ); ?>
			</div>
			<?php if ( 'full' != $sidebar ) : ?>
				<div class="shop-archive-sidebar col-md-3 col-lg-3">
					<?php get_sidebar( 'shop' ); ?>
				</div>
			<?php endif; ?>
		</div>
	</div>
</main>
<script>
	jQuery(document).ready(function($) {
		$(document).on('click', '.btn-switcher', function(e) {
			var _this = $(this),
				type = _this.data('style');
			if (type == 'list') {
				$('.products-by-category-wpb .products').addClass('list');
			} else {
				$('.products-by-category-wpb .products').removeClass('list');
			}

		});
	});
</script>
